SystemOrganization addCategory: #ImageFamilyTree!
SystemOrganization addCategory: #'ImageFamilyTree-Tree'!
SystemOrganization addCategory: #'ImageFamilyTree-StableTree'!

TestCase subclass: #ImageFamilyTreeJudgeTest
	instanceVariableNames: 'stream1 stream2 judge result'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ImageFamilyTree'!

!ImageFamilyTreeJudgeTest methodsFor: 'as yet unclassified' stamp: 'hjo 11/14/2010 16:49'!
test1IsAncestorOf2

	stream1 := '90377 Sedna is a trans-Neptunian object currently about three times as far from the Sun as Neptune. For the majority of its orbit it is the most distant known object in the Solar System other than long-period comets.' readStream.

	stream2 := '90377 Sedna is a trans-Neptunian object currently about three times as far from the Sun as Neptune. For the majority of its orbit it is the most distant known object in the Solar System other than long-period comets. Roughly two-thirds the size of Pluto, Sedna is hypothetically large enough to be rounded by its own gravity, and thus would qualify as a dwarf planet under current definitions. However, its distance makes determining its shape difficult.' readStream.

	judge := ImageFamilyTreeJudge new.
	judge stream1: stream1.
	judge stream2: stream2.
	result := judge judgeResult.
	self assert: (result isKindOf: AncestorJRIFT).
	self assert: result ancestor = 1.
	self assert: result descendant = 2.! !

!ImageFamilyTreeJudgeTest methodsFor: 'as yet unclassified' stamp: 'hjo 11/14/2010 16:50'!
test2IsAncestorOf1

	stream1 := '90377 Sedna is a trans-Neptunian object currently about three times as far from the Sun as Neptune. For the majority of its orbit it is the most distant known object in the Solar System other than long-period comets. Roughly two-thirds the size of Pluto, Sedna is hypothetically large enough to be rounded by its own gravity, and thus would qualify as a dwarf planet under current definitions. However, its distance makes determining its shape difficult.' readStream.

	stream2 := '90377 Sedna is a trans-Neptunian object currently about three times as far from the Sun as Neptune. For the majority of its orbit it is the most distant known object in the Solar System other than long-period comets.' readStream.

	judge := ImageFamilyTreeJudge new.
	judge stream1: stream1.
	judge stream2: stream2.
	result := judge judgeResult.
	self assert: (result isKindOf: AncestorJRIFT).
	self assert: result ancestor = 2.
	self assert: result descendant = 1.! !

!ImageFamilyTreeJudgeTest methodsFor: 'as yet unclassified' stamp: 'hjo 11/14/2010 16:35'!
testIdentical

	stream1 := '90377 Sedna is a trans-Neptunian object currently about three times as far from the Sun as Neptune. For the majority of its orbit it is the most distant known object in the Solar System other than long-period comets. Roughly two-thirds the size of Pluto, Sedna is hypothetically large enough to be rounded by its own gravity, and thus would qualify as a dwarf planet under current definitions. However, its distance makes determining its shape difficult.' readStream.

	stream2 := '90377 Sedna is a trans-Neptunian object currently about three times as far from the Sun as Neptune. For the majority of its orbit it is the most distant known object in the Solar System other than long-period comets. Roughly two-thirds the size of Pluto, Sedna is hypothetically large enough to be rounded by its own gravity, and thus would qualify as a dwarf planet under current definitions. However, its distance makes determining its shape difficult.' readStream.

	judge := ImageFamilyTreeJudge new.
	judge stream1: stream1.
	judge stream2: stream2.
	self assert: (judge judgeResult isKindOf: IdenticalJRIFT).! !

!ImageFamilyTreeJudgeTest methodsFor: 'as yet unclassified' stamp: 'hjo 11/20/2010 17:32'!
testShareCommonAncestor

	stream1 := '90377 Sedna is a trans-Neptunian object currently about three times as far from the Sun as Neptune. For the majority of its orbit it is the most distant known object in the Solar System other than long-period comets. Pluto' readStream.

	stream2 := '90377 Sedna is a trans-Neptunian object currently about three times as far from the Sun as Neptune. For the majority of its orbit it is the most distant known object in the Solar System other than long-period comets. Mars' readStream.

	judge := ImageFamilyTreeJudge new.
	judge stream1: stream1.
	judge stream2: stream2.
	result := judge judgeResult.
	self assert: (result isKindOf: ShareCommonAncestorJRIFT).
	self assert: result differenceStart = 218.
	self assert: result difference1 = 'Pluto'.
	self assert: result difference2 = 'Mars'.! !

TestCase subclass: #NaiveImageFamilyTreeJudgeTest
	instanceVariableNames: 'stream1 stream2 judge result'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ImageFamilyTree'!

!NaiveImageFamilyTreeJudgeTest methodsFor: 'as yet unclassified' stamp: 'hjo 11/25/2010 14:47'!
test1IsAncestorOf2

	stream1 := '90377 Sedna is a trans-Neptunian object currently about three times as far from the Sun as Neptune. For the majority of its orbit it is the most distant known object in the Solar System other than long-period comets.' readStream.

	stream2 := '90377 Sedna is a trans-Neptunian object currently about three times as far from the Sun as Neptune. For the majority of its orbit it is the most distant known object in the Solar System other than long-period comets. Roughly two-thirds the size of Pluto, Sedna is hypothetically large enough to be rounded by its own gravity, and thus would qualify as a dwarf planet under current definitions. However, its distance makes determining its shape difficult.' readStream.

	judge := NaiveImageFamilyTreeJudge new.
	judge stream1: stream1.
	judge stream2: stream2.
	result := judge judgeResult.
	self assert: (result isKindOf: AncestorJRIFT).
	self assert: result ancestor = 1.
	self assert: result descendant = 2.! !

!NaiveImageFamilyTreeJudgeTest methodsFor: 'as yet unclassified' stamp: 'hjo 11/25/2010 14:48'!
test2IsAncestorOf1

	stream1 := '90377 Sedna is a trans-Neptunian object currently about three times as far from the Sun as Neptune. For the majority of its orbit it is the most distant known object in the Solar System other than long-period comets. Roughly two-thirds the size of Pluto, Sedna is hypothetically large enough to be rounded by its own gravity, and thus would qualify as a dwarf planet under current definitions. However, its distance makes determining its shape difficult.' readStream.

	stream2 := '90377 Sedna is a trans-Neptunian object currently about three times as far from the Sun as Neptune. For the majority of its orbit it is the most distant known object in the Solar System other than long-period comets.' readStream.

	judge := NaiveImageFamilyTreeJudge new.
	judge stream1: stream1.
	judge stream2: stream2.
	result := judge judgeResult.
	self assert: (result isKindOf: AncestorJRIFT).
	self assert: result ancestor = 2.
	self assert: result descendant = 1.! !

!NaiveImageFamilyTreeJudgeTest methodsFor: 'as yet unclassified' stamp: 'hjo 11/25/2010 14:48'!
testIdentical

	stream1 := '90377 Sedna is a trans-Neptunian object currently about three times as far from the Sun as Neptune. For the majority of its orbit it is the most distant known object in the Solar System other than long-period comets. Roughly two-thirds the size of Pluto, Sedna is hypothetically large enough to be rounded by its own gravity, and thus would qualify as a dwarf planet under current definitions. However, its distance makes determining its shape difficult.' readStream.

	stream2 := '90377 Sedna is a trans-Neptunian object currently about three times as far from the Sun as Neptune. For the majority of its orbit it is the most distant known object in the Solar System other than long-period comets. Roughly two-thirds the size of Pluto, Sedna is hypothetically large enough to be rounded by its own gravity, and thus would qualify as a dwarf planet under current definitions. However, its distance makes determining its shape difficult.' readStream.

	judge := NaiveImageFamilyTreeJudge new.
	judge stream1: stream1.
	judge stream2: stream2.
	self assert: (judge judgeResult isKindOf: IdenticalJRIFT).! !

!NaiveImageFamilyTreeJudgeTest methodsFor: 'as yet unclassified' stamp: 'hjo 11/25/2010 14:48'!
testShareCommonAncestor

	stream1 := '90377 Sedna is a trans-Neptunian object currently about three times as far from the Sun as Neptune. For the majority of its orbit it is the most distant known object in the Solar System other than long-period comets. Pluto' readStream.

	stream2 := '90377 Sedna is a trans-Neptunian object currently about three times as far from the Sun as Neptune. For the majority of its orbit it is the most distant known object in the Solar System other than long-period comets. Mars' readStream.

	judge := NaiveImageFamilyTreeJudge new.
	judge stream1: stream1.
	judge stream2: stream2.
	result := judge judgeResult.
	self assert: (result isKindOf: ShareCommonAncestorJRIFT).
	self assert: result differenceStart = 218.
	self assert: result difference1 = 'Pluto'.
	self assert: result difference2 = 'Mars'.! !

TestCase subclass: #SsctTest
	instanceVariableNames: 'tree'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ImageFamilyTree-StableTree'!

SsctTest subclass: #ScctStep1Test
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ImageFamilyTree-StableTree'!

!ScctStep1Test methodsFor: 'as yet unclassified' stamp: 'hjo 12/13/2010 00:23'!
setUp

	super setUp.
	tree step! !

!ScctStep1Test methodsFor: 'as yet unclassified' stamp: 'hjo 12/13/2010 00:25'!
testComplete

	self assert: tree isComplete! !

!ScctStep1Test methodsFor: 'as yet unclassified' stamp: 'hjo 12/13/2010 00:25'!
testStreamPosition

	self assert: tree streamPosition = 0! !

!SsctTest methodsFor: 'as yet unclassified' stamp: 'hjo 12/13/2010 00:14'!
setUp

	super setUp.
	tree := StableStreamContentsTree newWithStreams:
				(#('hi' 'hello' 'hwajong' 'hill' 'apple') collect: [:each| each readStream])! !

!SsctTest methodsFor: 'as yet unclassified' stamp: 'hjo 12/13/2010 00:22'!
testComplete

	self deny: tree isComplete! !

!SsctTest methodsFor: 'as yet unclassified' stamp: 'hjo 12/13/2010 00:17'!
testStreamPosition

	self assert: tree streamPosition = 0! !

TestCase subclass: #StreamContentsTreeTest
	instanceVariableNames: 'tree'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ImageFamilyTree-Tree'!

StreamContentsTreeTest subclass: #ScttAddABTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ImageFamilyTree-Tree'!

ScttAddABTest subclass: #ScttAddABAddATest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ImageFamilyTree-Tree'!

!ScttAddABAddATest methodsFor: 'as yet unclassified' stamp: 'hjo 12/12/2010 19:30'!
setUp

	super setUp.
	tree add: 'a' readStream! !

!ScttAddABAddATest methodsFor: 'as yet unclassified' stamp: 'hjo 12/12/2010 19:33'!
testEqualEndPosition

	self assert: tree equalEndPosition = 1! !

!ScttAddABAddATest methodsFor: 'as yet unclassified' stamp: 'hjo 12/12/2010 19:33'!
testEqualStreams

	self assert: tree equalStreams size = 1.
	self assert: tree anyStream contents = 'a'! !

!ScttAddABAddATest methodsFor: 'as yet unclassified' stamp: 'hjo 12/12/2010 21:26'!
testSubTree

	| subTree |
	subTree := tree subTreeAtCharacter: $b.
	self assert: subTree equalStreams size = 1.
	self assert: subTree anyStream contents = 'ab'.
	self assert: subTree equalEndPosition = 2.
! !

!ScttAddABTest methodsFor: 'as yet unclassified' stamp: 'hjo 12/12/2010 19:28'!
setUp

	super setUp.
	tree add: 'ab' readStream! !

!ScttAddABTest methodsFor: 'as yet unclassified' stamp: 'hjo 12/12/2010 19:28'!
testEqualEndPosition

	self assert: tree equalEndPosition = 2! !

!ScttAddABTest methodsFor: 'as yet unclassified' stamp: 'hjo 12/12/2010 19:29'!
testEqualStreams

	self assert: tree equalStreams size = 1! !

StreamContentsTreeTest subclass: #ScttAddATest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ImageFamilyTree-Tree'!

ScttAddATest subclass: #ScttAddAAddABTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ImageFamilyTree-Tree'!

!ScttAddAAddABTest methodsFor: 'as yet unclassified' stamp: 'hjo 12/12/2010 18:14'!
setUp

	super setUp.
	tree add: 'ab' readStream.! !

!ScttAddAAddABTest methodsFor: 'as yet unclassified' stamp: 'hjo 12/12/2010 18:16'!
testSubTreeB

	| subTree |
	subTree := tree subTreeAtCharacter: $b.
	self assert: subTree equalStreams size = 1.
	self assert: subTree anyStream contents = 'ab'.
	self assert: subTree equalEndPosition = 2! !

ScttAddATest subclass: #ScttAddAAddATest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ImageFamilyTree-Tree'!

!ScttAddAAddATest methodsFor: 'as yet unclassified' stamp: 'hjo 12/12/2010 18:05'!
setUp

	super setUp.
	tree add: 'a' readStream! !

!ScttAddAAddATest methodsFor: 'as yet unclassified' stamp: 'hjo 12/12/2010 18:10'!
testEqualEndPosition

	self assert: tree equalEndPosition = 1! !

!ScttAddAAddATest methodsFor: 'as yet unclassified' stamp: 'hjo 12/12/2010 18:11'!
testEqualStreams

	self assert: tree equalStreams size = 2! !

ScttAddATest subclass: #ScttAddAAddBTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ImageFamilyTree-Tree'!

!ScttAddAAddBTest methodsFor: 'as yet unclassified' stamp: 'hjo 12/12/2010 17:59'!
setUp

	super setUp.
	tree add: 'b' readStream! !

!ScttAddAAddBTest methodsFor: 'as yet unclassified' stamp: 'hjo 12/12/2010 17:04'!
testEqualEndPosition

	self assert: tree equalEndPosition = 0! !

!ScttAddAAddBTest methodsFor: 'as yet unclassified' stamp: 'hjo 12/12/2010 17:04'!
testEqualStreams

	self assert: tree equalStreams size = 0! !

!ScttAddAAddBTest methodsFor: 'as yet unclassified' stamp: 'hjo 12/12/2010 18:07'!
testSubTreeA

	| subTree |
	subTree := tree subTreeAtCharacter: $a.
	self assert: subTree equalStreams size = 1.
	self assert: subTree equalStreams anyOne contents = 'a'.
	self assert: subTree equalEndPosition = 1! !

!ScttAddAAddBTest methodsFor: 'as yet unclassified' stamp: 'hjo 12/12/2010 18:07'!
testSubTreeB

	| subTree |
	subTree := tree subTreeAtCharacter: $b.
	self assert: subTree equalStreams size = 1.
	self assert: subTree equalStreams anyOne contents = 'b'.
	self assert: subTree equalEndPosition = 1! !

!ScttAddATest methodsFor: 'as yet unclassified' stamp: 'hjo 12/12/2010 17:01'!
setUp

	super setUp.
	tree add: 'a' readStream! !

!ScttAddATest methodsFor: 'as yet unclassified' stamp: 'hjo 12/12/2010 17:03'!
testEqualEndPosition

	self assert: tree equalEndPosition = 1! !

!ScttAddATest methodsFor: 'as yet unclassified' stamp: 'hjo 12/12/2010 17:02'!
testEqualStreams

	self assert: tree equalStreams size = 1! !

StreamContentsTreeTest subclass: #ScttHTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ImageFamilyTree-Tree'!

!ScttHTest methodsFor: 'as yet unclassified' stamp: 'hjo 12/12/2010 22:07'!
testHelloHi

	| helloTree hiTree |
	tree add: 'hello' readStream.
	tree add: 'hi' readStream.
	
	self assert: tree equalEndPosition = 1.
	helloTree := tree subTreeAtCharacter: $e.
	helloTree equalStreams size = 1.
	helloTree anyStream contents = 'hello'.
	helloTree equalEndPosition = 5.
	hiTree := tree subTreeAtCharacter: $i.
	hiTree equalStreams size = 1.
	hiTree anyStream contents = 'hi'.
	hiTree equalEndPosition = 2.
	! !

!StreamContentsTreeTest methodsFor: 'as yet unclassified' stamp: 'hjo 12/12/2010 16:57'!
setUp

	super setUp.
	tree := StreamContentsTree new.! !

!StreamContentsTreeTest methodsFor: 'as yet unclassified' stamp: 'hjo 12/12/2010 17:03'!
testEqualEndPosition

	self assert: tree equalEndPosition = 0! !

!StreamContentsTreeTest methodsFor: 'as yet unclassified' stamp: 'hjo 12/12/2010 19:29'!
testEqualStreams

	self assert: tree equalStreams isEmpty! !

Object subclass: #DuplicateImageFilePurger
	instanceVariableNames: 'fileDirectory unevaluatedChangesFiles judge judgeResult survivedChangesFiles'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ImageFamilyTree'!

!DuplicateImageFilePurger classSide methodsFor: 'as yet unclassified' stamp: 'hjo 12/12/2010 00:38'!
example

| d |
d := DuplicateImageFilePurger new.
d fileDirectory: (FileDirectory on: '/Users/daliot/programming/language/smalltalk/Squeak/Squeak3.10.2-7179-basic').
d setUnevaluatedChangesFilesToAllChangesFilesInTheFileDirectory.
20 timesRepeat: [d step]. self beep: 'croak'.
d canStep.
d run.
d nilJudge.! !

!DuplicateImageFilePurger methodsFor: 'as yet unclassified' stamp: 'hjo 11/25/2010 19:17'!
addJudgeFilesToSurvivedChangesFiles

	survivedChangesFiles setDefault:#defaultSurvivedChangesFiles for:self  withSetter: #survivedChangesFiles:.
	survivedChangesFiles add: judge stream1 name.
	survivedChangesFiles add: judge stream2 name.! !

!DuplicateImageFilePurger methodsFor: 'as yet unclassified' stamp: 'hjo 11/25/2010 19:54'!
canStep

	^unevaluatedChangesFiles size >= 2! !

!DuplicateImageFilePurger methodsFor: 'as yet unclassified' stamp: 'hjo 11/25/2010 19:18'!
defaultSurvivedChangesFiles

	^OrderedCollection new! !

!DuplicateImageFilePurger methodsFor: 'accessing' stamp: 'hjo 11/25/2010 18:48'!
fileDirectory: anUnixFileDirectory 

	fileDirectory := anUnixFileDirectory! !

!DuplicateImageFilePurger methodsFor: 'accessing' stamp: 'hjo 11/25/2010 19:19'!
nilJudge

	judge := nil! !

!DuplicateImageFilePurger methodsFor: 'as yet unclassified' stamp: 'hjo 12/5/2010 22:27'!
popUnevaluatedChangesFiles

	[^unevaluatedChangesFiles removeFirst] on: Error do: [:ex| (ex messageText= 'this collection is empty') ifTrue: [ NotEnoughFilesForDumplicateImageFilePurger new signal  ] ifFalse: [ex raise]]! !

!DuplicateImageFilePurger methodsFor: 'as yet unclassified' stamp: 'hjo 11/25/2010 19:55'!
run

	[ self canStep ] whileTrue: [self step].
	self moveAllUnevaluatedChangesFilesToSurvivedChangesFiles! !

!DuplicateImageFilePurger methodsFor: 'as yet unclassified' stamp: 'hjo 11/25/2010 19:41'!
setStreamAtIndexByPopUnevaluatedChangesFile: anInteger

	judge perform: (self streamSetterAtIndex: anInteger) with: (FileStream readOnlyFileNamed: self popUnevaluatedChangesFiles)! !

!DuplicateImageFilePurger methodsFor: 'file' stamp: 'hjo 11/25/2010 19:03'!
setUnevaluatedChangesFilesToAllChangesFilesInTheFileDirectory

	| entryNames |
	entryNames := fileDirectory entries collect: [:each| each name].
	unevaluatedChangesFiles := entryNames select: [:each| (fileDirectory class extensionFor:each) = 'changes'].
	unevaluatedChangesFiles := unevaluatedChangesFiles asOrderedCollection! !

!DuplicateImageFilePurger methodsFor: 'as yet unclassified' stamp: 'hjo 12/5/2010 22:29'!
step

	[
		judge isNil
			ifTrue: [
				judge := NaiveImageFamilyTreeJudge 
					fileNamed: unevaluatedChangesFiles removeFirst 
					fileNamed: unevaluatedChangesFiles removeFirst. ]
			ifFalse: [
				self assert: [judgeResult notNil].
				judgeResult reuseJudge: judge of: self.
				].
		
		judgeResult := judge judgeResult.
		judgeResult deleteRedundantImageFilesFor: judge.
	] ignoreError: NotEnoughFilesForDumplicateImageFilePurger! !

!DuplicateImageFilePurger methodsFor: 'as yet unclassified' stamp: 'hjo 11/25/2010 19:39'!
streamSetterAtIndex: aSmallInteger 

	aSmallInteger = 1 ifTrue: [^#stream1:].
	aSmallInteger = 2 ifTrue: [^#stream2:].
	self error: 'why?'! !

!DuplicateImageFilePurger methodsFor: 'accessing' stamp: 'hjo 11/25/2010 19:18'!
survivedChangesFiles: anOrderedCollection 

	survivedChangesFiles := anOrderedCollection ! !

Object subclass: #ImageFamilyTreeJudge
	instanceVariableNames: 'stream1 stream2 shorterStream longerStream binarySearch differBegin'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ImageFamilyTree'!

!ImageFamilyTreeJudge classSide methodsFor: 'as yet unclassified' stamp: 'hjo 11/20/2010 17:21'!
fileNamed: fileName1 fileNamed: fileName2

	|instance|
	instance := ImageFamilyTreeJudge new.
	instance stream1: (FileStream readOnlyFileNamed: fileName1).
	instance stream2: (FileStream readOnlyFileNamed: fileName2).
	^instance! !

!ImageFamilyTreeJudge methodsFor: 'accessing' stamp: 'hjo 11/20/2010 21:49'!
binarySearch

	^binarySearch! !

!ImageFamilyTreeJudge methodsFor: 'testing' stamp: 'hjo 11/20/2010 20:56'!
decideShortStreamAndLongStream

	stream1 size > stream2 size
		ifTrue: [ shorterStream := stream2. longerStream := stream1 ]
		ifFalse: [ shorterStream := stream1. longerStream := stream2 ]. 
! !

!ImageFamilyTreeJudge methodsFor: 'testing' stamp: 'hjo 11/20/2010 21:12'!
judgeResult

	self decideShortStreamAndLongStream.
	self makeBinarySearch.
	
	self streamsAreIdentical
		ifTrue: [ ^IdenticalJRIFT new ].
	
	differBegin := binarySearch solve.
	
	^shorterStream size - 1 = differBegin
		ifTrue: [
			(shorterStream == stream1)
				ifTrue: [AncestorJRIFT new ancestor: 1; descendant: 2]
				ifFalse: [AncestorJRIFT new ancestor: 2; descendant: 1] ]
		ifFalse: [
			ShareCommonAncestorJRIFT differenceStart: binarySearch root x + 2 stream1: stream1 stream2: stream2 ]
	! !

!ImageFamilyTreeJudge methodsFor: 'accessing' stamp: 'hjo 11/21/2010 22:36'!
longerStream

	^longerStream! !

!ImageFamilyTreeJudge methodsFor: 'testing' stamp: 'hjo 11/20/2010 21:00'!
makeBinarySearch
			
	binarySearch := BinarySearcherForIntegerToBoolean new.
	binarySearch left: 0.
	binarySearch right: shorterStream size.
	binarySearch equation: [:pos| 
		shorterStream position: pos.
		longerStream position: pos.
		shorterStream peek = longerStream peek ].! !

!ImageFamilyTreeJudge methodsFor: 'accessing' stamp: 'hjo 11/21/2010 22:36'!
shorterStream

	^shorterStream! !

!ImageFamilyTreeJudge methodsFor: 'accessing' stamp: 'hjo 11/20/2010 17:55'!
stream1

	^stream1! !

!ImageFamilyTreeJudge methodsFor: 'accessing' stamp: 'hjo 11/14/2010 16:42'!
stream1: aReadStream 

	stream1 := aReadStream! !

!ImageFamilyTreeJudge methodsFor: 'accessing' stamp: 'hjo 11/20/2010 17:56'!
stream2

	^stream2! !

!ImageFamilyTreeJudge methodsFor: 'accessing' stamp: 'hjo 11/14/2010 16:42'!
stream2: aReadStream 

	stream2 := aReadStream! !

!ImageFamilyTreeJudge methodsFor: 'testing' stamp: 'hjo 11/20/2010 21:02'!
streamsAreIdentical

	^shorterStream size = longerStream size 
		and: [(binarySearch value: shorterStream size) = 1] ! !

Object subclass: #JudgeResultIFT
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ImageFamilyTree'!

JudgeResultIFT subclass: #AncestorJRIFT
	instanceVariableNames: 'ancestor descendant'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ImageFamilyTree'!

!AncestorJRIFT methodsFor: 'accessing' stamp: 'hjo 11/14/2010 16:50'!
ancestor

	^ancestor! !

!AncestorJRIFT methodsFor: 'accessing' stamp: 'hjo 11/14/2010 16:51'!
ancestor: anInteger

	ancestor := anInteger! !

!AncestorJRIFT methodsFor: 'file' stamp: 'hjo 11/25/2010 18:15'!
deleteRedundantImageFilesFor: aNaiveImageFamilyTreeJudge 

	"This method does not work for non-file streams."
	| streamToDelete changesFileName imageFileName |
	streamToDelete := ancestor = 1 ifTrue: [ aNaiveImageFamilyTreeJudge stream1 ] ifFalse: [ aNaiveImageFamilyTreeJudge stream2].
	
	changesFileName := streamToDelete name.
	imageFileName := (FileDirectory baseNameFor: changesFileName) , FileDirectory dot, 'image'.
	
	FileDirectory default deleteFileNamed: imageFileName ifAbsent: [].
	FileDirectory default deleteFileNamed: changesFileName ifAbsent: [].! !

!AncestorJRIFT methodsFor: 'accessing' stamp: 'hjo 11/14/2010 16:53'!
descendant

	^descendant! !

!AncestorJRIFT methodsFor: 'accessing' stamp: 'hjo 11/14/2010 16:54'!
descendant: anInteger

	descendant := anInteger! !

!AncestorJRIFT methodsFor: 'as yet unclassified' stamp: 'hjo 12/5/2010 18:06'!
reuseJudge: aNaiveImageFamilyTreeJudge of: aDuplicateImageFilePurger 
	| selector |
	"(aDuplicateImageFilePurger streamSetterAtIndex: ancestor)"
	selector := aDuplicateImageFilePurger streamSetterAtIndex: ancestor.
	aNaiveImageFamilyTreeJudge perform: selector with: 
			(FileStream readOnlyFileNamed: aDuplicateImageFilePurger popUnevaluatedChangesFiles)
! !

!AncestorJRIFT methodsFor: 'testing' stamp: 'hjo 11/21/2010 22:39'!
verifyJudge: anImageFamilyTreeJudge 

	| s1 s2 |
	s1 := anImageFamilyTreeJudge stream1 reset.
	s2 := anImageFamilyTreeJudge stream2 reset.
	ancestor = 1 ifTrue: [
			^s1 contents = (s2 next: s1 size)
		].
	ancestor = 2 ifTrue: [
			^s2 contents = (s1 next: s2 size)
		].
	self error: 'wtf'! !

JudgeResultIFT subclass: #IdenticalJRIFT
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ImageFamilyTree'!

JudgeResultIFT subclass: #ShareCommonAncestorJRIFT
	instanceVariableNames: 'differenceStart difference1 difference2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ImageFamilyTree'!

!ShareCommonAncestorJRIFT classSide methodsFor: 'as yet unclassified' stamp: 'hjo 11/20/2010 17:38'!
differenceStart: anInteger stream1: stream1 stream2: stream2

	| instance |
	instance := ShareCommonAncestorJRIFT new.
	instance differenceStart: anInteger.
	stream1 position: instance differenceStart-1.
	instance difference1: stream1 upToEnd.
	stream2 position: instance differenceStart-1.		
	instance difference2: stream2 upToEnd.
	^instance! !

!ShareCommonAncestorJRIFT methodsFor: 'as yet unclassified' stamp: 'hjo 11/25/2010 19:27'!
deleteRedundantImageFilesFor: aNaiveImageFamilyTreeJudge 

	"i wont delete anything"! !

!ShareCommonAncestorJRIFT methodsFor: 'as yet unclassified' stamp: 'hjo 11/20/2010 17:22'!
difference1

	^difference1! !

!ShareCommonAncestorJRIFT methodsFor: 'accessing' stamp: 'hjo 11/20/2010 17:24'!
difference1: aByteString 

	difference1 := aByteString ! !

!ShareCommonAncestorJRIFT methodsFor: 'accessing' stamp: 'hjo 11/20/2010 17:23'!
difference2

	^difference2! !

!ShareCommonAncestorJRIFT methodsFor: 'as yet unclassified' stamp: 'hjo 11/20/2010 17:24'!
difference2: aByteString 

	difference2 := aByteString ! !

!ShareCommonAncestorJRIFT methodsFor: 'accessing' stamp: 'hjo 11/14/2010 19:11'!
differenceStart

	^differenceStart! !

!ShareCommonAncestorJRIFT methodsFor: 'accessing' stamp: 'hjo 11/14/2010 19:12'!
differenceStart: aSmallInteger 

	differenceStart := aSmallInteger ! !

!ShareCommonAncestorJRIFT methodsFor: 'as yet unclassified' stamp: 'hjo 11/25/2010 19:39'!
reuseJudge: aNaiveImageFamilyTreeJudge of: aDuplicateImageFilePurger 
	aDuplicateImageFilePurger addJudgeFilesToSurvivedChangesFiles.
	aDuplicateImageFilePurger setStreamAtIndexByPopUnevaluatedChangesFile: 1.
	aDuplicateImageFilePurger setStreamAtIndexByPopUnevaluatedChangesFile: 2! !

!ShareCommonAncestorJRIFT methodsFor: 'testing' stamp: 'hjo 11/20/2010 18:56'!
verifyJudge: anImageFamilyTreeJudge 

	"can be very slow"
	| stream1 stream2 |
	stream1 := anImageFamilyTreeJudge stream1 reset.
	stream2 := anImageFamilyTreeJudge stream2 reset.
	[stream1 atEnd not and: [stream2 atEnd not]] whileTrue: [stream1 next = stream2 next ifFalse: [^(Array with: false with: stream1 position)]].
	^true! !

Object subclass: #NaiveImageFamilyTreeJudge
	instanceVariableNames: 'stream1 stream2 shorterStream longerStream differBegin'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ImageFamilyTree'!

!NaiveImageFamilyTreeJudge classSide methodsFor: 'as yet unclassified' stamp: 'hjo 11/25/2010 14:48'!
fileNamed: fileName1 fileNamed: fileName2

	|instance|
	instance := NaiveImageFamilyTreeJudge new.
	instance stream1: (FileStream readOnlyFileNamed: fileName1).
	instance stream2: (FileStream readOnlyFileNamed: fileName2).
	^instance! !

!NaiveImageFamilyTreeJudge methodsFor: 'testing' stamp: 'hjo 11/25/2010 14:47'!
decideShortStreamAndLongStream

	stream1 size > stream2 size
		ifTrue: [ shorterStream := stream2. longerStream := stream1 ]
		ifFalse: [ shorterStream := stream1. longerStream := stream2 ]. 
! !

!NaiveImageFamilyTreeJudge methodsFor: 'testing' stamp: 'hjo 11/25/2010 17:45'!
judgeResult

	self decideShortStreamAndLongStream.
	longerStream reset.
	shorterStream reset.
	[shorterStream atEnd] whileFalse: [shorterStream next = longerStream next ifFalse: [^ShareCommonAncestorJRIFT differenceStart: shorterStream position stream1: stream1 stream2: stream2]].
	^longerStream size = shorterStream size 
		ifTrue: [ IdenticalJRIFT new]
		ifFalse: [(shorterStream == stream1)
				ifTrue: [AncestorJRIFT new ancestor: 1; descendant: 2]
				ifFalse: [AncestorJRIFT new ancestor: 2; descendant: 1]].! !

!NaiveImageFamilyTreeJudge methodsFor: 'accessing' stamp: 'hjo 11/25/2010 14:47'!
longerStream

	^longerStream! !

!NaiveImageFamilyTreeJudge methodsFor: 'accessing' stamp: 'hjo 11/25/2010 14:47'!
shorterStream

	^shorterStream! !

!NaiveImageFamilyTreeJudge methodsFor: 'accessing' stamp: 'hjo 11/25/2010 14:47'!
stream1

	^stream1! !

!NaiveImageFamilyTreeJudge methodsFor: 'accessing' stamp: 'hjo 11/25/2010 14:47'!
stream1: aReadStream 

	stream1 := aReadStream! !

!NaiveImageFamilyTreeJudge methodsFor: 'accessing' stamp: 'hjo 11/25/2010 14:47'!
stream2

	^stream2! !

!NaiveImageFamilyTreeJudge methodsFor: 'accessing' stamp: 'hjo 11/25/2010 14:47'!
stream2: aReadStream 

	stream2 := aReadStream! !

Object subclass: #StableStreamContentsTree
	instanceVariableNames: 'endOfEqualPosition streams subTrees'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ImageFamilyTree-StableTree'!

!StableStreamContentsTree classSide methodsFor: 'as yet unclassified' stamp: 'hjo 12/13/2010 01:32'!
newWithStreams: anArray 

	^self newWithStreams: anArray endOfEqualPosition: 0! !

!StableStreamContentsTree classSide methodsFor: 'as yet unclassified' stamp: 'hjo 12/13/2010 01:31'!
newWithStreams: anArray endOfEqualPosition: anInteger

	| instance |
	instance := self new.
	instance streams: anArray.
	instance endOfEqualPosition: anInteger.
	^instance! !

!StableStreamContentsTree methodsFor: 'accessing' stamp: 'hjo 12/13/2010 01:22'!
endOfEqualPosition

	^endOfEqualPosition! !

!StableStreamContentsTree methodsFor: 'accessing' stamp: 'hjo 12/13/2010 01:32'!
endOfEqualPosition: aSmallInteger 

	endOfEqualPosition := aSmallInteger! !

!StableStreamContentsTree methodsFor: 'enumerating' stamp: 'hjo 12/18/2010 08:47'!
findEndOfEqualPosition

	| nextCharacters |
	streams do: [:each| each position: endOfEqualPosition].
	[(streams allSatisfy: [:each| each atEnd not]) and: [
	nextCharacters := streams collect: [:each| each next].
	 nextCharacters asSet size = 1 ]]
		whileTrue: [endOfEqualPosition := endOfEqualPosition+1].! !

!StableStreamContentsTree methodsFor: 'initialize-release' stamp: 'hjo 12/13/2010 01:19'!
initialize

	super initialize.
	endOfEqualPosition := 0.! !

!StableStreamContentsTree methodsFor: 'enumerating' stamp: 'hjo 12/13/2010 02:05'!
produceSubTrees

	|group|
	group := Dictionary new.
	streams do: [:each| 
		each position: endOfEqualPosition.
		group at: each next add: each].
	subTrees := Dictionary new.
	group keysAndValuesDo: [:character :orderedCollection| 
		character notNil ifTrue: [
		subTrees at: character put: (self class newWithStreams: orderedCollection endOfEqualPosition: endOfEqualPosition) ] ]! !

!StableStreamContentsTree methodsFor: 'recursing' stamp: 'hjo 12/13/2010 02:05'!
run

	streams size = 1 ifTrue: [ endOfEqualPosition := streams anyOne size. ^self ].
	self findEndOfEqualPosition.
	self produceSubTrees.
	self runSubTrees
! !

!StableStreamContentsTree methodsFor: 'recursing' stamp: 'hjo 12/13/2010 01:35'!
runSubTrees

	subTrees values do: [:each| each run ]! !

!StableStreamContentsTree methodsFor: 'recursing' stamp: 'hjo 12/17/2010 18:26'!
statisticalTree

	| statTree |
	statTree := self statisticalTreeWithoutPercent.
	statTree computePercent.
	^statTree! !

!StableStreamContentsTree methodsFor: 'recursing' stamp: 'hjo 12/17/2010 18:25'!
statisticalTreeWithoutPercent

	| temp |
	subTrees isNil ifTrue: [ temp := nil]
		ifFalse: [	temp := Dictionary new.
	subTrees keysAndValuesDo: [ :key :value| 
		temp at: key put: value statisticalTreeWithoutPercent ]].

	^StatisticalTree 
		endOfEqualPosition: self endOfEqualPosition
		streamCount: self streams size
		subTrees: temp! !

!StableStreamContentsTree methodsFor: 'accessing' stamp: 'hjo 12/17/2010 17:47'!
streams

	^streams! !

!StableStreamContentsTree methodsFor: 'accessing' stamp: 'hjo 12/13/2010 01:30'!
streams: anArray

	streams := anArray! !

!StableStreamContentsTree methodsFor: 'enumerating' stamp: 'hjo 12/17/2010 22:58'!
verifyEndOfEqualPosition

	| beforeItShouldBeEqual afterItShouldBeDifferent |
	beforeItShouldBeEqual := (streams collect: [:each| 
			each position: endOfEqualPosition-5.
			each next: 5. 
		]) asSet size = 1.
	afterItShouldBeDifferent := (streams collect: [:each| 
			each position: endOfEqualPosition.
			each next: 5. 
		]) asSet size > 1.
	^beforeItShouldBeEqual and: [afterItShouldBeDifferent]! !

Object subclass: #StatisticalTree
	instanceVariableNames: 'endOfEqualPosition streamCount percent subTrees'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ImageFamilyTree-StableTree'!

!StatisticalTree classSide methodsFor: 'as yet unclassified' stamp: 'hjo 12/17/2010 18:13'!
endOfEqualPosition: integer1 streamCount: integer2

	| instance |
	instance := self new.
	instance endOfEqualPosition: integer1.
	instance streamCount: integer2.
	self halt.
	^instance! !

!StatisticalTree classSide methodsFor: 'as yet unclassified' stamp: 'hjo 12/17/2010 18:18'!
endOfEqualPosition: integer1 streamCount: integer2 subTrees: aDictionary

	| instance |
	instance := self new.
	instance endOfEqualPosition: integer1.
	instance streamCount: integer2.
	instance subTrees: aDictionary.
	^instance! !

!StatisticalTree classSide methodsFor: 'as yet unclassified' stamp: 'hjo 12/17/2010 18:18'!
subTrees: aDictionary 
	self shouldBeImplemented! !

!StatisticalTree methodsFor: 'percent' stamp: 'hjo 12/17/2010 18:39'!
computePercent

	self computePercentWithMyPercent: 100.0! !

!StatisticalTree methodsFor: 'percent' stamp: 'hjo 12/17/2010 18:39'!
computePercentWithMyPercent: aFloat

	percent := aFloat.
	subTrees notNil
		ifTrue: [ subTrees do: [:each| each computePercentWithParentTree: self ] ]! !

!StatisticalTree methodsFor: 'percent' stamp: 'hjo 12/17/2010 18:40'!
computePercentWithParentTree: aStatisticalTree 

	self computePercentWithMyPercent: (self streamCount / aStatisticalTree streamCount * aStatisticalTree percent).	
! !

!StatisticalTree methodsFor: 'accessing' stamp: 'hjo 12/17/2010 18:05'!
endOfEqualPosition: aSmallInteger 

	endOfEqualPosition := aSmallInteger ! !

!StatisticalTree methodsFor: 'accessing' stamp: 'hjo 12/17/2010 18:30'!
percent

	^percent! !

!StatisticalTree methodsFor: 'printing' stamp: 'hjo 12/17/2010 18:33'!
printOn: stream

	super printOn: stream.
	percent notNil ifTrue: [
		stream nextPut: $(.
		stream print: percent.
		stream nextPutAll: '%)'.
		]! !

!StatisticalTree methodsFor: 'accessing' stamp: 'hjo 12/17/2010 18:29'!
streamCount

	^streamCount! !

!StatisticalTree methodsFor: 'accessing' stamp: 'hjo 12/17/2010 18:06'!
streamCount: aSmallInteger 

	streamCount := aSmallInteger ! !

!StatisticalTree methodsFor: 'accessing' stamp: 'hjo 12/17/2010 18:19'!
subTrees: aDictionary 

	subTrees := aDictionary ! !

Object subclass: #StreamContentsTree
	instanceVariableNames: 'equalStreams equalEndPosition subTrees'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ImageFamilyTree-Tree'!

!StreamContentsTree methodsFor: 'as yet unclassified' stamp: 'hjo 12/12/2010 22:12'!
add: aReadStream 

	| stream1 stream2 newTree subTree1 subTree2 char1 char2 subContents diffChar newSubTree |
	self equalEndPosition = 0 ifTrue: [
		self equalStreams add: aReadStream.
		self equalEndPosition: aReadStream size.
		^self].
	(aReadStream size = self anyStream size and: 
		[aReadStream contents = self anyStream contents])
		ifTrue: [self equalStreams add: aReadStream. ^self].
	(aReadStream size > self anyStream size)
		ifTrue: [	
			aReadStream position: 0.
			subContents := aReadStream next: self anyStream size.
			subContents = self anyStream contents
				ifTrue: [
					aReadStream position: self anyStream size.
					diffChar := aReadStream next.
					newSubTree := self subTreeAtCharacter: diffChar.
					newSubTree add: aReadStream.
					^self
					].
		].
	"implies .. aReadStream size < self anyStream size"
	stream1 := aReadStream.
	stream2 := self anyStream.
	stream1 position: 0.
	stream2 position: 0.
	[(stream1 atEnd not and: [stream2 atEnd not])
	  and: [
	char1 := stream1 next.
	char2 := stream2 next.
	char1 = char2] ] whileTrue.

	char1 = char2
		ifTrue: [
			newTree := self class new.
			newTree add: aReadStream.
			newTree become: self.
			self subTrees at: stream2 next put: newTree.
		]
		ifFalse: [
	subTree1 := self class new.
	subTree1 add: stream1.
	subTree2 := self class new.
	subTree2 add: stream2.
			
	newTree := self class new.
	newTree equalEndPosition: stream1 position - 1.
	newTree subTrees at: char1 put: subTree1.
	newTree subTrees at: char2 put: subTree2.
	self become: newTree.
	]! !

!StreamContentsTree methodsFor: 'as yet unclassified' stamp: 'hjo 12/12/2010 16:38'!
addTree: aStreamContentsTree 

	| myStream otherStream |
	myStream := self anyStream.
	otherStream := aStreamContentsTree anyStream.
	
	myStream reset.
	otherStream reset.
	[myStream atEnd or: [otherStream atEnd]] whileFalse: 
		[ myStream next = otherStream next
			ifTrue: [self equalEndPosition: myStream position]
		].
	self subTrees at: otherStream next ifAbsentPut: [aStreamContentsTree]! !

!StreamContentsTree methodsFor: 'as yet unclassified' stamp: 'hjo 12/12/2010 16:27'!
anyStream

	^self equalStreams anyOne! !

!StreamContentsTree methodsFor: 'defaults' stamp: 'hjo 12/12/2010 15:59'!
defaultEqualEndPosition

	^0! !

!StreamContentsTree methodsFor: 'defaults' stamp: 'hjo 12/12/2010 15:57'!
defaultEqualStreams

	^OrderedCollection new! !

!StreamContentsTree methodsFor: 'defaults' stamp: 'hjo 12/12/2010 16:17'!
defaultSubTrees

	^Dictionary new! !

!StreamContentsTree methodsFor: 'accessing' stamp: 'hjo 12/12/2010 15:59'!
equalEndPosition

	^equalEndPosition setDefault: #defaultEqualEndPosition for: self withSetter: #equalEndPosition:! !

!StreamContentsTree methodsFor: 'accessing' stamp: 'hjo 12/12/2010 15:59'!
equalEndPosition: anObject
		
	equalEndPosition := anObject! !

!StreamContentsTree methodsFor: 'accessing' stamp: 'hjo 12/12/2010 15:56'!
equalStreams

	^equalStreams setDefault: #defaultEqualStreams for: self withSetter: #equalStreams:! !

!StreamContentsTree methodsFor: 'accessing' stamp: 'hjo 12/12/2010 15:57'!
equalStreams: anOrderedCollection
		
	equalStreams := anOrderedCollection! !

!StreamContentsTree methodsFor: 'as yet unclassified' stamp: 'hjo 12/12/2010 16:16'!
subTreeAtCharacter: aCharacter 

	^self subTrees at: aCharacter ifAbsentPut: [ self class new ].! !

!StreamContentsTree methodsFor: 'accessing' stamp: 'hjo 12/12/2010 16:16'!
subTrees

	^subTrees setDefault: #defaultSubTrees for: self withSetter: #subTrees:! !

!StreamContentsTree methodsFor: 'accessing' stamp: 'hjo 12/12/2010 16:16'!
subTrees: anObject
		
	subTrees := anObject! !

Error subclass: #NotEnoughFilesForDumplicateImageFilePurger
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ImageFamilyTree'!
